#include "sophie.h"
#include "sophie_init.h"

CISavi2 *pSAVI;

void sophie_init(void)
{
	const char *ClientName = "sophie";

	CISweepClassFactory2 *pFactory;
	HRESULT hr;

	hr = DllGetClassObject((REFIID)&SOPHOS_CLSID_SAVI2, (REFIID)&SOPHOS_IID_CLASSFACTORY2, (void **) &pFactory);

	if (!(hr == SOPHOS_S_OK))
	{
		printf("ERROR: Could not initialize SAVI class/object\n");
		exit(1);
	}
	else
	{
		hr = pFactory->pVtbl->CreateInstance(pFactory, NULL, &SOPHOS_IID_SAVI2, (void **) &pSAVI );
			
		pFactory->pVtbl->Release(pFactory);
	
		if (hr == SOPHOS_S_OK)
		{
			hr = pSAVI->pVtbl->InitialiseWithMoniker(pSAVI, ClientName);
/*
Veng_ComponentServer_GetObject
0x4004f811 CLTAB_Factory_Create ()
0x080545d8 ??
*/

			if (SOPHOS_FAILED(hr))
			{
				sophie_print(0, "ERROR: Failed to initialize SAVI [%ld]", (long) hr);
				pSAVI->pVtbl->Release(pSAVI);
				pSAVI= NULL;
				exit(1);
			}

			/* Engine configuration */
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_DO_FULL_SWEEP, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_DO_FULL_SWEEP);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_DO_FULL_SWEEP to %s",
					SOPHIE_SOPHOS_DO_FULL_SWEEP);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_DYNAMIC_DECOMPRESSION, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_DYNAMIC_DECOMPRESSION);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_DYNAMIC_DECOMPRESSION to %s",
					SOPHIE_SOPHOS_DYNAMIC_DECOMPRESSION);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_FULL_MACRO_SWEEP, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_FULL_MACRO_SWEEP);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_FULL_MACRO_SWEEP to %s",
					SOPHIE_SOPHOS_FULL_MACRO_SWEEP);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_IGNORE_TEMPLATE_BIT, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_IGNORE_TEMPLATE_BIT);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_IGNORE_TEMPLATE_BIT to %s",
					SOPHIE_SOPHOS_IGNORE_TEMPLATE_BIT);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_OLE2_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_OLE2_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_OLE2_HANDLING to %s",
					SOPHIE_SOPHOS_OLE2_HANDLING);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_VBA3_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_VBA3_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_VBA3_HANDLING to %s",
					SOPHIE_SOPHOS_VBA3_HANDLING);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_VBA5_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_VBA5_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_VBA5_HANDLING to %s",
					SOPHIE_SOPHOS_VBA5_HANDLING);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_DECOMPRESS_VBA5, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_DECOMPRESS_VBA5);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_DECOMPRESS_VBA5 to %s",
					SOPHIE_SOPHOS_DECOMPRESS_VBA5);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_DO_EMULATION, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_DO_EMULATION);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_DO_EMULATION to %s",
					SOPHIE_SOPHOS_DO_EMULATION);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_PE_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_PE_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_PE_HANDLING to %s",
					SOPHIE_SOPHOS_PE_HANDLING);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_XF_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_XF_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_XF_HANDLING to %s",
					SOPHIE_SOPHOS_XF_HANDLING);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_PM97_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_PM97_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_PM97_HANDLING to %s",
					SOPHIE_SOPHOS_PM97_HANDLING);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_ZIP_DECOMPRESSION, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_ZIP_DECOMPRESSION);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_ZIP_DECOMPRESSION to %s",
					SOPHIE_SOPHOS_ZIP_DECOMPRESSION);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_ARJ_DECOMPRESSION, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_ARJ_DECOMPRESSION);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_ARJ_DECOMPRESSION to %s",
					SOPHIE_SOPHOS_ARJ_DECOMPRESSION);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_RAR_DECOMPRESSION, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_RAR_DECOMPRESSION);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_RAR_DECOMPRESSION to %s",
					SOPHIE_SOPHOS_RAR_DECOMPRESSION);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_UUE_DECOMPRESSION, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_UUE_DECOMPRESSION);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_UUE_DECOMPRESSION to %s",
					SOPHIE_SOPHOS_UUE_DECOMPRESSION);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_GZIP_DECOMPRESSION, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_GZIP_DECOMPRESSION);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_GZIP_DECOMPRESSION to %s",
					SOPHIE_SOPHOS_GZIP_DECOMPRESSION);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_TAR_DECOMPRESSION, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_TAR_DECOMPRESSION);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_TAR_DECOMPRESSION to %s",
					SOPHIE_SOPHOS_TAR_DECOMPRESSION);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_CMZ_DECOMPRESSION, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_CMZ_DECOMPRESSION);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_CMZ_DECOMPRESSION to %s",
					SOPHIE_SOPHOS_CMZ_DECOMPRESSION);
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_MAX_RECURSION_DEPTH, SOPHOS_TYPE_U16, SOPHIE_SOPHOS_MAX_RECURSION_DEPTH);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_MAX_RECURSION_DEPTH to %s",
					SOPHIE_SOPHOS_MAX_RECURSION_DEPTH);

			/*
			  These are the ones not found in SAVI include files - I added them since they were listed in configuration output
			*/
			
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_LHA_DECOMPRESSION, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_LHA_DECOMPRESSION);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_LHA_DECOMPRESSION to %s",
					SOPHIE_SOPHOS_LHA_DECOMPRESSION);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_SFX_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_SFX_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_SFX_HANDLING to %s",
					SOPHIE_SOPHOS_SFX_HANDLING);

/* seems not to be supported under UNIX
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_MSCABINET_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_MSCABINET_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_MSCABINET_HANDLING to %s",
					SOPHIE_SOPHOS_MSCABINET_HANDLING);
*/
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_TNEF_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_TNEF_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_TNEF_HANDLING to %s",
					SOPHIE_SOPHOS_TNEF_HANDLING);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_MSCOMPRESS_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_MSCOMPRESS_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_MSCOMPRESS_HANDLING to %s",
					SOPHIE_SOPHOS_MSCOMPRESS_HANDLING);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_OF95DECRYPT_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_OF95DECRYPT_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_OF95DECRYPT_HANDLING to %s",
					SOPHIE_SOPHOS_OF95DECRYPT_HANDLING);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_DELETE_ALL_MACROS, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_DELETE_ALL_MACROS);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_DELETE_ALL_MACROS to %s",
					SOPHIE_SOPHOS_DELETE_ALL_MACROS);

			/* 29-Jul-2001 - for IDE 3.48, Engine 2.5 */
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_VBE, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_VBE);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_VBE to %s",
					SOPHIE_SOPHOS_VBE);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_EXEC_FILE_DISINFECTION, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_EXEC_FILE_DISINFECT);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_EXEC_FILE_DISINFECTION to %s",
					SOPHIE_SOPHOS_EXEC_FILE_DISINFECT);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_VISIO_FILE_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_VISIO_FILE_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_VISIO_FILE_HANDLING to %s",
					SOPHIE_SOPHOS_VISIO_FILE_HANDLING);

			/* 25-Feb-2002 - for IDE 3.55, Engine 2.9 */
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_MIME, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_MIME);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_MIME to %s",
					SOPHIE_SOPHOS_MIME);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_ACTIVE_MIME_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_ACTIVE_MIME_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_ACTIVE_MIME_HANDLING to %s",
					SOPHIE_SOPHOS_ACTIVE_MIME_HANDLING);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_DEL_VBA5_PROJECT, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_DEL_VBA5_PROJECT);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_DEL_VBA5_PROJECT to %s",
					SOPHOS_DEL_VBA5_PROJECT);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_SCRAP_OBJECT_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_SCRAP_OBJECT_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_SCRAP_OBJECT_HANDLING to %s",
					SOPHIE_SOPHOS_SCRAP_OBJECT_HANDLING);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_SRP_STREAM_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_SRP_STREAM_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_SRP_STREAM_HANDLING to %s",
					SOPHIE_SOPHOS_SRP_STREAM_HANDLING);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_OFFICE2001_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_OFFICE2001_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_OFFICE2001_HANDLING to %s",
					SOPHIE_SOPHOS_OFFICE2001_HANDLING);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_UPX, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_UPX);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_UPX to %s",
					SOPHIE_SOPHOS_UPX);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_MAC, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_MAC);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_MAC to %s",
					SOPHIE_SOPHOS_MAC);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_SAFE_MAC_DF_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_SAFE_MAC_DF_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_SAFE_MAC_DF_HANDLING to %s",
					SOPHIE_SOPHOS_SAFE_MAC_DF_HANDLING);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_PALM_PILOT_HANDLING, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_PALM_PILOT_HANDLING);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_PALM_PILOT_HANDLING to %s",
					SOPHIE_SOPHOS_PALM_PILOT_HANDLING);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_HQX_DECOMPRESSION, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_HQX_DECOMPRESSION);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_HQX_DECOMPRESSION to %s",
					SOPHIE_SOPHOS_HQX_DECOMPRESSION);
			
			/* 13-May-2002 - for IDE 3.57, Engine 2.10 */
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_PDF, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_PDF);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_PDF to %s",
					SOPHIE_SOPHOS_PDF);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_RTF, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_RTF);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_RTF to %s",
					SOPHIE_SOPHOS_RTF);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_HTML, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_HTML);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_HTML to %s",
					SOPHIE_SOPHOS_HTML);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_ELF, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_ELF);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_ELF to %s",
					SOPHIE_SOPHOS_ELF);

			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_WORDB, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_WORDB);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_WORDB to %s",
					SOPHIE_SOPHOS_WORDB);

			/* 01-Jun-2002 - for IDE 3.58, Engine 2.10 */
			hr = pSAVI->pVtbl->SetConfigValue(pSAVI, SOPHOS_PDF, SOPHOS_TYPE_U32, SOPHIE_SOPHOS_OUTLOOK_EXPRESS);
			if (SOPHOS_FAILED(hr))
				sophie_print(0, "NOTICE: Unable to setup configuration value SOPHOS_OUTLOOK_EXPRESS to %s",
					SOPHIE_SOPHOS_OUTLOOK_EXPRESS);
		}

	}
}

void sophie_show_settings(void)
{
	CIEnumEngineConfig *pConfigEnum = NULL;
	CIEngineConfig *pConfig = NULL;
	U32 pcFetched;
	HRESULT hr;

	hr = pSAVI->pVtbl->GetConfigEnumerator(	pSAVI,
											(REFIID)&SOPHOS_IID_ENUM_ENGINECONFIG,
											(void **)&pConfigEnum
										 );

	if (SOPHOS_FAILED(hr))
	{
		sophie_print(0, "WARNING: Could not get configuration data");
	}

	hr = pConfigEnum->pVtbl->Reset(pConfigEnum);

	if (SOPHOS_FAILED(hr))
	{
		sophie_print(0, "WARNING: Could not reset configuration data enumerator");
	}

	printf("+-----------------------------------+-----+-----+\n");
	printf("| Configuration parameter           | Type|Value|\n");
	printf("+-----------------------------------+-----+-----+\n");
	
	while (pConfigEnum->pVtbl->Next(pConfigEnum, 1, (void **) &pConfig, &pcFetched) == SOPHOS_S_OK)
	{
		show_config_details(pSAVI, pConfig);
		pConfig->pVtbl->Release(pConfig);
	}

	pConfigEnum->pVtbl->Release(pConfigEnum);
	
	printf("+-----------------------------------+-----+-----+\n");

}

int show_config_details(CISavi2 *pSAVI, CIEngineConfig *pConfig)
{
	const U32 arraySize = 100;
	TCHAR name[100];
	TCHAR value[100];
	U32 type;
	HRESULT hr;

	name[0] = '\0';
	value[0] = '\0';
	type = 0;

	hr = pConfig->pVtbl->GetName(pConfig, arraySize, name, NULL);
	if (SOPHOS_FAILED(hr))
	{
		sophie_print(0, "WARNING: Couldn't get options name [0x%08lx]", (unsigned long) hr);
		return 0;
	}

	hr = pConfig->pVtbl->GetType(pConfig, &type);
	if (SOPHOS_FAILED(hr))
	{
		sophie_print(0, "WARNING: Couldn't get size [0x%08lx]", (unsigned long) hr);
		return 0;
	}

	hr = pSAVI->pVtbl->GetConfigValue(pSAVI, name, type, arraySize, value, NULL);
	if (SOPHOS_FAILED(hr))
	{
		sophie_print(0, "WARNING: Couldn't get value of '%s' [0x%08lx]", name, (unsigned long) hr);
		return 0;
	}

	printf("| %-34s|  %ld  | %3s |\n", name, (unsigned long) type, value);

	return 1;
}
